commit:     13ed346019d30425b9762b01a1d22961df3dd10b
Author:     Mike Pagano <mpagano <AT> gentoo <DOT> org>
AuthorDate: Thu May 22 23:04:48 2025 +0000
Commit:     Mike Pagano <mpagano <AT> gentoo <DOT> org>
CommitDate: Thu May 22 23:05:23 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=13ed3460

net-firewall/ipset: add 7.24, net_namespace.h patch

Check for 'int \*id' in the pernet_operations struct
fails for later versions of kernels as the declaration
is now 'int * const id'. Fix check to include both versions.

Signed-off-by: Mike Pagano <mpagano <AT> gentoo.org>

 net-firewall/ipset/Manifest                        |   1 +
 net-firewall/ipset/files/ipset-net_namespace.patch |  11 ++
 net-firewall/ipset/ipset-7.24.ebuild               | 119 +++++++++++++++++++++
 3 files changed, 131 insertions(+)

diff --git a/net-firewall/ipset/Manifest b/net-firewall/ipset/Manifest
index afca750b4594..9ec1656c94f0 100644
--- a/net-firewall/ipset/Manifest
+++ b/net-firewall/ipset/Manifest
@@ -1 +1,2 @@
 DIST ipset-7.23.tar.bz2 695655 BLAKE2B 
a596630d12a8bcc1383475627e5e62b7be4c17570ae9d3650b9dbcac0ec46324e1ac7c0e7e11f674fb5354871538f6f15e57476ac752b1ac1415023d837904e6
 SHA512 
5a43c790abf157a55db5a9a22cb5f28a225f5c7969beda81566a2259aa82c9d852979eb805b11b4347f47c6a0c2cc4de6f14e4733bee5b562844422a45fb9dab
+DIST ipset-7.24.tar.bz2 695548 BLAKE2B 
52e05313353e7b5fe969d5f113794238356bf900b4e7ac4693c05164ecde0826d0e911dcae67bb4103f49b587f94f561d14dcfebb78c5c231013fda7d36a81da
 SHA512 
18ccb49bd38083f0556b11e1d17f43791c52a2b094c9a500b6f770796b17e8e70c3860a628eac2252eb672b1fc9de734d3a0e0823d61dd9be7b4188adc6dd214

diff --git a/net-firewall/ipset/files/ipset-net_namespace.patch 
b/net-firewall/ipset/files/ipset-net_namespace.patch
new file mode 100644
index 000000000000..5349635967c2
--- /dev/null
+++ b/net-firewall/ipset/files/ipset-net_namespace.patch
@@ -0,0 +1,11 @@
+--- a/configure.ac     2025-05-22 22:36:57.332625302 -0000
++++ b/configure.ac     2025-05-22 22:37:17.729090112 -0000
+@@ -401,7 +401,7 @@ fi
+ 
+ AC_MSG_CHECKING([kernel source for id in struct pernet_operations])
+ if test -f $ksourcedir/include/net/net_namespace.h && \
+-   $AWK '/^struct pernet_operations /,/^}/' 
$ksourcedir/include/net/net_namespace.h | $GREP -q 'int \*id;'; then
++   $AWK '/^struct pernet_operations /,/^}/' 
$ksourcedir/include/net/net_namespace.h | $GREP -qE 'int \*id;|int \* const 
id'; then
+       AC_MSG_RESULT(yes)
+       AC_SUBST(HAVE_NET_OPS_ID, define)
+ else

diff --git a/net-firewall/ipset/ipset-7.24.ebuild 
b/net-firewall/ipset/ipset-7.24.ebuild
new file mode 100644
index 000000000000..953c5079e247
--- /dev/null
+++ b/net-firewall/ipset/ipset-7.24.ebuild
@@ -0,0 +1,119 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+MODULES_OPTIONAL_IUSE=modules
+inherit autotools bash-completion-r1 linux-mod-r1 systemd
+
+DESCRIPTION="IPset tool for iptables, successor to ippool"
+HOMEPAGE="https://ipset.netfilter.org/ https://git.netfilter.org/ipset/";
+SRC_URI="https://ipset.netfilter.org/${P}.tar.bz2";
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~loong ~ppc ~ppc64 ~riscv ~x86"
+
+RDEPEND="
+       net-firewall/iptables
+       net-libs/libmnl:=
+"
+DEPEND="${RDEPEND}"
+BDEPEND="virtual/pkgconfig"
+
+DOCS=( ChangeLog INSTALL README UPGRADE )
+
+# configurable from outside, e.g. /etc/portage/make.conf
+IP_NF_SET_MAX=${IP_NF_SET_MAX:-256}
+
+PATCHES=(
+       "${FILESDIR}/${PN}-bash-completion.patch"
+       "${FILESDIR}/${PN}-net_namespace.patch"
+)
+
+src_prepare() {
+       default
+       eautoreconf
+}
+
+pkg_setup() {
+       get_version
+       CONFIG_CHECK="NETFILTER"
+       ERROR_NETFILTER="ipset requires NETFILTER support in your kernel."
+       CONFIG_CHECK+=" NETFILTER_NETLINK"
+       ERROR_NETFILTER_NETLINK="ipset requires NETFILTER_NETLINK support in 
your kernel."
+       # It does still build without NET_NS, but it may be needed in future.
+       #CONFIG_CHECK="${CONFIG_CHECK} NET_NS"
+       #ERROR_NET_NS="ipset requires NET_NS (network namespace) support in 
your kernel."
+       CONFIG_CHECK+=" !PAX_CONSTIFY_PLUGIN"
+       ERROR_PAX_CONSTIFY_PLUGIN="ipset contains constified variables 
(#614896)"
+
+       build_modules=0
+       if use modules; then
+               if linux_config_src_exists && linux_chkconfig_builtin "MODULES" 
; then
+                       if linux_chkconfig_present "IP_NF_SET" || \
+                               linux_chkconfig_present "IP_SET"; then #274577
+                               eerror "There is IP{,_NF}_SET or 
NETFILTER_XT_SET support in your kernel."
+                               eerror "Please either build ipset with modules 
USE flag disabled"
+                               eerror "or rebuild kernel without IP_SET 
support and make sure"
+                               eerror "there is NO kernel ip_set* modules in 
/lib/modules/<your_kernel>/... ."
+                               die "USE=modules and in-kernel ipset support 
detected."
+                       else
+                               einfo "Modular kernel detected. Gonna build 
kernel modules..."
+                               build_modules=1
+                       fi
+               else
+                       eerror "Nonmodular kernel detected, but USE=modules. 
Either build"
+                       eerror "modular kernel (without IP_SET) or disable 
USE=modules"
+                       die "Nonmodular kernel detected, will not build kernel 
modules"
+               fi
+       fi
+
+       [[ ${build_modules} -eq 1 ]] && linux-mod-r1_pkg_setup
+}
+
+src_configure() {
+       export bashcompdir="$(get_bashcompdir)"
+
+       econf \
+               --enable-bashcompl \
+               $(use_with modules kmod) \
+               --with-maxsets=${IP_NF_SET_MAX} \
+               --with-ksource="${KV_DIR}" \
+               --with-kbuild="${KV_OUT_DIR}"
+}
+
+src_compile() {
+       einfo "Building userspace"
+
+       local modlist=( 
xt_set=kernel/net/netfilter/ipset/:"${S}":kernel/net/netfilter/:
+                                       
em_ipset=kernel/net/sched:"${S}":kernel/net/sched/:modules )
+
+       for i in 
ip_set{,_bitmap_{ip{,mac},port},_hash_{ip{,mac,mark,port{,ip,net}},mac,net{,port{,net},iface,net}},_list_set};
 do
+               modlist+=( 
${i}=kernel/net/netfilter/ipset/:"${S}":kernel/net/netfilter/ipset )
+       done
+
+       emake
+
+       if [[ ${build_modules} -eq 1 ]]; then
+               einfo "Building kernel modules"
+               linux-mod-r1_src_compile
+       fi
+}
+
+src_install() {
+       einfo "Installing userspace"
+       default
+
+       find "${ED}" -name '*.la' -delete || die
+
+       newinitd "${FILESDIR}"/ipset.initd-r7 ${PN}
+       newconfd "${FILESDIR}"/ipset.confd-r1 ${PN}
+       systemd_newunit "${FILESDIR}"/ipset.systemd-r1 ${PN}.service
+       keepdir /var/lib/ipset
+
+       if [[ ${build_modules} -eq 1 ]]; then
+               einfo "Installing kernel modules"
+               linux-mod-r1_src_install
+       fi
+}

Reply via email to